# connect to the db
import mysql.connector
dbconn = mysql.connector.connect(user='ta_anna', password='',
                                  host='127.0.0.1',
                                  database='sampledb')
cur = dbconn.cursor()


#%% pull all of the family last names and sort them alphabetically
"""
select *
from family
order by last_name
"""

#%% pull all of the family last names and sort them in reverse alphabetical order
"""
select *
from family
order by last_name desc
"""

#%% select just the first two interests, ordered alphabetically
"""
select * 
from interest
order by interest
limit 2
"""

#%% select the next two interests
"""
select * 
from interest
order by interest
limit 2
offset 2
"""

#%%
# look up the id of the williams family
"""
select id from family
where last_name = 'williams'
""" 
# id for williams is 1

#%% 
# get the members of the williams family
"""
select * 
from family_member
where family_id = 1
"""

#%%
# get just the parents of the williams family
"""
select * 
from family_member
where relation in ('f', 'm')
"""

#%%
# get all individuals born before 1980
"""
SELECT * 
from family_member
where birth_date < '1980-01-01'
"""


#%% get all individuals born in November who are older than 18
# you will need the EXTRACT() function
"""
SELECT * 
from family_member
where current_age > 18
and EXTRACT(month from birth_date) = 11
"""


#%%
# get all individuals whose first name begins with m or j
# you will need the substr() function
"""
select * 
from family_member 
where substr(first_name, 1, 1) in ('m', 'j')
"""

#%% get all individuals who either have first name starting with m and are a parent,
# OR have first name starting with j and are a child

"""
SELECT * 
FROM family_member 
WHERE (substr(first_name, 1, 1) = 'm' and relation='c')
  OR  (substr(first_name, 1, 1) = 'j' and relation in ('m', 'f'))
"""


#%%
# select the members of the family_member table. derive a column to see if their 
# birthday this year has already passed. If the birthday has passed, return
# a 1, otherwise return a 0. Alias the new column as 'birthday_passed'
# HINT: use the DATE_FORMAT function and CURRENT_DATE internal variable: 
# https://dev.mysql.com/doc/refman/5.7/en/date-and-time-functions.html#function_date-format
"""
select first_name, birth_date, 
 case 
  /* birthday is after or exactly today */ 
  when DATE_FORMAT(birth_date, '%m-%d') >= DATE_FORMAT(CURRENT_DATE, '%m-%d')
     then 0
     
  /* birthday is before today */
  when DATE_FORMAT(birth_date, '%m-%d') < DATE_FORMAT(CURRENT_DATE, '%m-%d')
     then 1
  end as birthday_passed
from family_member 
"""