# connect to the db
import mysql.connector
dbconn = mysql.connector.connect(user='ta_anna', password='',
                                  host='127.0.0.1',
                                  database='sampledb')
cur = dbconn.cursor()


#%% How many of each type of family relation are there?
"""
select relation, count(*)
from family_member
group by relation
"""

#%% what happens if you leave out the "group by" clause in the above?
"""
you only get one row back with a random relation and a total count (which
is an uninformative result)
"""


#%% how many members are there in each family?
"""
select family_id, count(*) as num_members
from family_member
group by family_id
"""

#%% select just the families with five members
"""
select family_id, count(*) as num_members
from family_member
group by family_id
having count(*) = 5
"""

#%% what is the oldest and youngest age in each family? 
"""
select family_id, max(current_age) as oldest_age, min(current_age) as youngest_age
from family_member
group by family_id
"""

#%%
# Using the value of oldest_age, find the individual(s) who have this age
"""
select * 
from family_member
where current_age = 52
"""


#%% what is the oldest and youngest age in each family, only considering children? 
"""
select family_id, max(current_age) as oldest_age, min(current_age) as youngest_age
from family_member
where relation='c'
group by family_id
"""

#%% how many members of each relation type are there in each family?
# within each family, order the relations as m, f, c
"""
select family_id, relation, count(*) as num_members
from family_member
group by family_id, relation
order by family_id, case relation when 'm' then 1 when 'f' then 2 else 3 end
"""



#%% what is the id of the interest for 'sports'?
"""
select id 
from interest
where interest = 'sports'
"""
# 2

#%% using the above answer, how many people like sports? 
"""
select count(*)
from family_member_interest
where interest_id = 2
"""

#%% bonus 1: "SQL Pivot"
# return a result set with the following structure:
# - one row per family
# - four columns: total, m, f, c
# - the total column is the total number of family members, and the remaining
#     columns are the number of members of each type, respectively
# hint: use case statements with sum()
"""
select family_id, 
 count(*) as total, 
 sum(case when relation='m' then 1 else 0 end) as m,
 sum(case when relation='f' then 1 else 0 end) as f,
 sum(case when relation='c' then 1 else 0 end) as c
from family_member 
group by family_id
order by family_id
"""


#%% bonus 2
# For each family, return a count of the number of birthdays they've already
# celebrated, and the number they still have remaining
# hint: create a temporary table building on the result you found for a similar question
# in the previous exercise
"""
CREATE TEMPORARY TABLE birthday_passed
AS
select family_id, 
    count(*) as n_total ,
    sum(
     case 
      /* birthday is after or exactly today */ 
      when DATE_FORMAT(birth_date, '%m-%d') >=  DATE_FORMAT(CURRENT_DATE, '%m-%d')
         then 0
         
      /* birthday is before today */
      when DATE_FORMAT(birth_date, '%m-%d') < DATE_FORMAT(CURRENT_DATE, '%m-%d')
         then 1
      end 
    ) as n_birthday_passed
    
from family_member 
group by family_id
"""

"""
select *, n_total - n_birthday_passed as n_upcoming_birthday
from birthday_passed a 
"""
