# connect to the db
import mysql.connector
dbconn = mysql.connector.connect(user='ta_anna', password='',
                                  host='127.0.0.1',
                                  database='sampledb')
cur = dbconn.cursor()



#%% print a list of everyone's first and last names, and also include the family id.
# Order by last_name followed by the person's age (oldest to youngest)

"""
select family_id, first_name, last_name, current_age
from family_member as a
join family as b
 on a.family_id = b.id
order by last_name, family_id, current_age desc
"""

#%% who are the individuals who like sports? return their first name and family id

"""
SELECT first_name, family_id, interest
FROM interest as a
JOIN family_member_interest as b
 on a.interest = 'sports'
 and a.id = b.interest_id
JOIN family_member as c
 on b.family_member_id = c.id
"""



#%% Create a temporary table or subquery with the average age in each family.
# then join this table the family_member table. Then derive a new
# column that says 'older than average' or 'younger than average'
# for each individual
"""
select a.*, b.avg_family_age,
  case when current_age > avg_family_age 
         then 'older than aveage' 
         else 'younger than agerage' end as age_message
from family_member as a
join (select family_id, avg(current_age) as avg_family_age
from family_member
group by 1 ) as b
 on a.family_id = b.family_id
"""


#%% how many families have children age 18 or older?
 # your result should  be a single number
"""
select count(*) 
FROM(
    select family_id
    from family_member as a
    where relation = 'c'
    and current_age >= 18
    group by 1
)as C
"""

#%% in one query, return the two individuals who are the oldest
"""
select b.*
from 
(select max(current_age) as max_age
from family_member
) as a
join family_member as b
 on a.max_age = b.current_age
 
"""

#%% for each family, find and compare the age of the youngest parent 
# and the oldest child

"""
SELECT parents.family_id, age_youngest_parent, age_oldest_child, 
  age_youngest_parent - age_oldest_child
FROM
(SELECT family_id, min(current_age) as age_youngest_parent
from family_member
where relation in ('m', 'f')
group by family_id
 ) as parents
join
(SELECT family_id, max(current_age) as age_oldest_child
from family_member as a
where relation = 'c'
group by family_id
 ) as children
on parents.family_id = children.family_id
order by parents.family_id
"""


# OR

"""
SELECT *, age_youngest_parent - age_oldest_child
FROM
(
    SELECT family_id, 
     min(case when relation in('f', 'm') then current_age else NULL end ) as age_youngest_parent,
     max(case when relation = 'c' then current_age else NULL end ) as age_oldest_child
    FROM family_member
    GROUP by family_id
) as a
"""


#%% who are the oldest children in each family?
# hint: you will need a subquery or temporary table

"""
create temporary table oldest_child_age
as 
 select family_id, max(current_age) as age
  from family_member as a 
 where relation = 'c'
 group by 1
"""

"""
select b.family_id, first_name, current_age 
from oldest_child_age as a
join family_member as b
on a.family_id = b.family_id
and a.age = b.current_age
"""


#%% Find the person whose only interest is sports
cur.execute("""
  select id from interest 
 where interest = 'sports'
 """)
sports_id = cur.fetchone()[0]
cur.execute("""
select * 
from 
(
  select family_member_id, 
         count(*) as n_interests, 
         sum(case when interest_id = {} then 1 else 0 end) as likes_sports
  from family_member_interest
  group by family_member_id
) as a
where n_interests  = 1
and likes_sports = 1
""".format(sports_id)
  )


#%% *which* families have no children under 18? 
#  (use a query, do not just look at the output of the above)
# your result should be a list of last names
"""
select last_name
from
(
select family_id, sum(case when current_age >= 18 then 1 else 0 end) as n_gt18
from family_member as a
where relation = 'c'
group by 1 
) as a
join family as b
 on a.family_id = b.id
where n_gt18 = 0
"""